package component.system;

import java.util.Hashtable;

// database which contains Contracts (the method for reading in contracts
// will probably change).  But for now contracts have to manually added.
public class Contracts {
	private static Hashtable contracts = new Hashtable();
	
	// Contract key: depends on type of contract (eg. the key for a TimingContract is "TimingContract" + target name + thunkname)
	public static void addContract(String contractKey, Contract contract) {
		contracts.put(contractKey,contract);
	}
		
	// Contract key: depends on type of contract (eg. the key for a TimingContract is "TimingContract" + target name + thunkname)
	public static Contract getContract(String contractKey) {
		return (Contract)contracts.get(contractKey);
	}			
}