package component.system;

public class PriorityExecutionLoop extends Thread {
	private EDFMessageQueueSimple messageQueue;

    public PriorityExecutionLoop(EDFMessageQueueSimple messageQueue, int priority) {
    	this.messageQueue = messageQueue;
        start();
   		// setPriority(priority);        
    }

    public void run() {
    	while (true) {
    		Message message = messageQueue.getNextMessage();
    		if (message != null) {
    			message.execute();
    		}
    		// TODO: use notify to wake thread instead of active waiting
    	}	
    }
}


