package component.system;

public class TimingContract extends ResourceContract {
	
	// member variables are public for performance issues
	// negative value: variable not used
	
	// minimum allowed start time of the message (in msec)
	public long minStartTime;
	
	// maximum allowed start time of the message (in msec)
	public long maxStartTime;
	
	// maximum allowed end time of the message (in msec)
	public long maxEndTime;
	
	public TimingContract() {
		this(-1,-1,-1);
	}
	
	public TimingContract(long minst, long maxst, long maxet) {
		minStartTime = minst;
		maxStartTime = maxst;
		maxEndTime = maxet;
	}
}