package component.examples.concurrentplayfield;
import java.io.*;
import java.util.*;

public class Pos
  implements Serializable
  {
     public int x;
     public int y;
     public Pos()
       {
	  Random random=new Random();
	  x=random.nextInt(31)+1;
	  y=random.nextInt(31)+1;
       }
     static Pos random()
       {
	  return new Pos();
       }
     public Pos(int nx, int ny)
       {
	  x=nx;
	  y=ny;
       }
     public Pos add(Pos delta)
       {
	  return new Pos(x+delta.x,y+delta.y);
       }
     public boolean equals(Object o)
       {
	  return ((Pos)o).x==x && ((Pos)o).y==y;
       }
     public Pos left()
       {
	  return new Pos(x-1,y);
       }
     public Pos right()
       {
	  return new Pos(x+1,y);
       }
     public Pos up()
       {
	  return new Pos(x,y-1);
       }
     public Pos down()
       {
	  return new Pos(x,y+1);
       }
     public int hashCode()
       {
	  return x*100+y;
       }
  }

