package component.examples.java_problems;
import java.net.*;
import java.io.*;
import java.util.*;

/**
 * This class can open a connection to another listening TCP/IP socket.
 */

public class SocketSender
{
   public SocketSender(String args[])
     {
	super();
	try 
	  {
	     InetAddress address = InetAddress.getByName(args[0]);
	     System.out.println("Connecting to "+address+" port 8081");
	     Socket socket = new Socket(address,8081);
	     System.out.println("Socket opened");
	     OutputStream outputstream = socket.getOutputStream();
	     System.out.println("Allocating array of 10M");
	     byte yeah[]= new byte[10*1024*1024];
	     System.out.println("Sending data");
	     long now = new Date().getTime();
	     outputstream.write(yeah);
	     outputstream.flush();
	     outputstream.close();
	     now = new Date().getTime()-now;
	     System.out.println("Done (time = "+now+" ms)");
	     System.out.println(" --> "+10*1024*1000/now+" k/s");
	     System.out.println(" --> "+10*1000/now+" M/s");
	  }
	catch (Exception e)
	  {
	     System.out.println(e);
	  }
     }
   static void main(String args[])
     {
	new SocketSender(args);
     }
}
