package component.parser;
import component.productions.*;

public class ASTCompilationUnit extends SimpleNode 
{
   public ASTCompilationUnit(int id) {super(id);}
   public Production generateProductions()
     {
	return listChildProductions();
     }
   public void generateSource()
     {
	int i=0;
	output("/* Component Parser Version "+Transformer.version()+" -- Generated Code */\n");
	while(i<children.length)
	  {
	     SimpleNode child=(SimpleNode)children[i++];
	     if (child instanceof ASTTypeDeclaration) output("\n");
	     child.generateSource();
	  }
     }
}
