package component.parser;
import component.productions.*;

public class ASTImportDeclaration extends SimpleNode {
   public ASTImportDeclaration(int id) 
     {
	super(id);
     }
   public Production generateProductions() 
     {
	return null;
     }
   static public boolean importcsdone=false;
   static public void importCS()
     {
	if (!importcsdone)
	  {
	     output("import component.system.*;\n");
	     importcsdone=true;	  
	  }
     }
   public void generateSource()
     {	
	/* sanity check 
	 * import component.system.* is not necesary 
	 */	
	assertion(children.length==1);
	importCS();
	if ("component.system".compareTo(children[0].toString())==0)
	  {
	     warning("component.system.* will be automatically included");
	     return;
	  }
	output("import ");
	generateChildSources();
	if (fields!=null) output(fields[0]);
	output(";\n");
     }
}
