package component.parser;
import component.productions.*;

public class ASTName extends SimpleNode {
   public ASTName(int id) {super(id);}
   public void generateSource()
     {
	String s=(String)fields[0];
	if (s.charAt(0)=='<')
	  {
	     if (s.charAt(1)=='|')
	       {
		  output("((");
		  output(fields[1]);
		  output(")inmessage.getField(\"");
		  output(fields[2]);
		  output("\"))");
	       }
	     else
	       {
		  output("(inmessage.getField(\"");
		  output(fields[1]);
		  output("\"))");
	       }
	     return;
	  }
	if (s.charAt(0)=='>')
	  {
	     if (s.charAt(1)=='|')
	       {
		  output("((");
		  output(fields[1]);
		  output(")inmessage.getHiddenField(\"");
		  output(fields[2]);
		  output("\"))");
	       }
	     else
	       {
		  output("(inmessage.getHiddenField(\"");
		  output(fields[1]);
		  output("\"))");
	       }
	     return;
	  }
	outputFields(".");}
   public Production generateProductions()
     {
	String s=(String)fields[0];
	if (s.charAt(0)=='<')
	  {
	     if (s.charAt(1)=='|')
	       return new GetFieldProduction(null,(String)fields[2],(String)fields[1]);
	     else
	       return new GetFieldProduction(null,(String)fields[1]);}
	if (s.charAt(0)=='>')
	  {
	     if (s.charAt(1)=='|')
	       return new GetFieldProduction(getCurrentClassName(),(String)fields[2],(String)fields[1]);
	     else
	       return new GetFieldProduction(getCurrentClassName(),(String)fields[1]);}
	return null;
     }
   public String toString()
     {
	int i=1;
	StringBuffer sb = new StringBuffer();
	sb.append(fields[0]);
	while(i<fields.length)
	  {
	     sb.append(".");
	     sb.append (fields[i++]);
	  }
	return sb.toString();
     }
}
