package component.parser;
import component.productions.*;

public class ASTPrimarySuffix extends SimpleNode {
   public ASTPrimarySuffix(int id) {super(id);}
   
   public void generateSource()
     {
	SimpleNode c;
	// we hebben ofwel geen kinderen
	if (children==null || children.length==0)
	  {
	     output(".");
	     outputFields("");
	     return;
	  }
	//  ofwel is het een allocationewxpression
	c=(SimpleNode)children[0];
	if (c instanceof ASTAllocationExpression)
	  {
	     output(".");
	     generateChildSources();
	     return;
	  }
	// ofwel is het een expression
	if (c instanceof ASTExpression)
	  {
	     output("[");
	     generateChildSources();
	     output("]");
	     return;
	  }
	// of anders is het een argumentenlijst
	generateChildSources();
     }
   public Production generateProductions()
     {
	return sequenceChildProductions();
     }
}
