package component.parser;
import component.productions.*;

public class ASTTryStatement extends SimpleNode {
  public ASTTryStatement(int id) {super(id);}
  public void generateSource()
	  {
        int fi=0, ci=1;
        // eerst try uitvoeren
        output("try \n");
        // dan de eerste bvlock uitvoeren
        ((SimpleNode)children[0]).generateSource();
        // vanaf nu al de fields aflopen tot er geen meer zijn
        while(fi<fields.length)
	        {
                String fs=(String)fields[fi++];
	            output(fs);
                if (fs.compareTo("catch")==0)
	                {
	                output(" (");
                    ((SimpleNode)children[ci++]).generateSource();
                    output(")\n");
	                }
                ((SimpleNode)children[ci++]).generateSource();
	        }
	  }

   public Production generateProductions()
     {
	SimpleNode bl;
	int i=0, ci=1;
	Production p1,p2=null,p3=null;
	bl=(SimpleNode)children[0];
	p1=Production.createtry(bl.generateProductions());
	while(i<fields.length)
	  {
	     String fs=(String)fields[i++];
	     if (fs.compareTo("catch")==0) 
	       {
		  bl=(SimpleNode)children[++ci];
		  ci++;
		  p2=Production.choice(p2,bl.generateProductions());
	       }
	     else if (fs.compareTo("finally")==0)
	       {
		  bl=(SimpleNode)children[ci++];
		  p3=bl.generateProductions();
	       }
	     else fatal("Internal Try Statement");
	  }
	return Production.sequence(p1,Production.sequence(p2,p3));
     }
}
