package component.parser;
import component.productions.*;

public class ASTWhileStatement extends SimpleNode {
   public ASTWhileStatement(int id) {super(id);}
   public void generateSource()
     {
	generateChildSources("while( ",")\n","");
     }
   public Production generateProductions()
     {
	Production e=((SimpleNode)children[0]).generateProductions();
	Production b=((SimpleNode)children[1]).generateProductions();
	return 
	  Production.sequence(Production.deep(e),
			      Production.loop(Production.sequence(b,e)));
     }
}
