package component.productions;

public class GetFieldProduction extends Production {
    protected String hidden;
    protected String var,type=null;
    public GetFieldProduction(String ishiddenin, String v)
    	{
        hidden=ishiddenin;
        var=v;
    	}
    public GetFieldProduction(String ishiddenin, String v, String t)
    	{
        hidden=ishiddenin;
        var=v;
        type=t;
    	}
    public Production deepCopy()
    	{
        return new GetFieldProduction(hidden,var,type);
    	}
   public Production createTry()
     {
	return deepCopy();
     }
   public void setVar(String v)
     {
        var=v;
    	}
   public String toString()
     {
	if (hidden!=null)
	  return "__"+hidden+"/"+var;
	return var;	
     }
   protected Production remangleGetFields()
     {
	addGetField(this);
	return null;
     }
}
