package component.productions;

public class OrProduction extends ListProduction
{
   public OrProduction(Production l, Production r)
     {
	super(l,r);
     }
   public Production deepCopy()
     {
	return new OrProduction(deep(content),deep(next));
     }
   public String toString()
     {
	return "( " + endString();
     }
   public Production createTry()
     {
	return choice(createtry(content), createtry(next));
     }
   public String endString()
     {
	if (next==null) return content.toString() + " | )";
	if (next instanceof OrProduction) 
	  return content.toString() + " | " + ((OrProduction)next).endString();
	return content.toString() + " | " + next.toString() + ")";
     }
   protected Production remangleGetFields()
     {
	return choice(
		      remangleGetFields(content),
		      remangleGetFields(next));
     }
}
