/* Component Parser Version 1.7 -- Generated Code */
package component.system;
import component.system.*;
import java.lang.reflect.*;
import java.util.*;

public abstract class Component extends Global

{public String name;public ComponentImpl impl; public Port  system; public Port  self;protected Port getPortByName ( String name) 
{
 Class klasse = getClass();
try 
{
 Field field = klasse.getField(name);
 Object obj;
try 
{
obj=field.get(this);}
catch ( IllegalAccessException e)
{
Fatal("Port '"+name+"' of class '"+klasse+"' is not public", e);
return null;}

 Class fieldtype = field.getType();
if (fieldtype.isAssignableFrom(Class.forName("component.system.MultiPort")))
{
if (obj==null)
Fatal("MultiPort '"+name+"' is not initialised", null);
 MultiPort mp = (MultiPort)obj;
return (Port)mp.newPort();}

else if (fieldtype.isAssignableFrom(Class.forName("component.system.Port")))
{
if (obj==null)
Fatal("Port '"+name+"' non existent", null);
return (Port)obj;}
}
catch ( NoSuchFieldException e)
{
Fatal("No such port available '"+name+"' in "+klasse+" (maybe not public ?)", e);}
catch ( ClassNotFoundException e)
{
Fatal("Unable to find a class", e);}

return null;}
 public synchronized void  GetPort(Port port, Message inmessage, Message outmessage) 
{
 String portname = ((String)inmessage.getField("Name"));
 Port portlookingfor = getPortByName(portname);
if (portlookingfor==null)
Fatal("cannot find port "+portname+" by its name");
portlookingfor.setInformation(((String)inmessage.getField("Information")));
{ outmessage.putField("Invoke","PortId");
outmessage.putField("Id",portlookingfor.getId());
(port).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 public synchronized void  Connect(Port port, Message inmessage, Message outmessage) 
{
{ outmessage.putField("Invoke","ConnectPortWith");
outmessage.putField("PortId",(inmessage.getField("PortId")));
outmessage.putField("With",(inmessage.getField("With")));
(system).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 public synchronized void  Disconnect(Port port, Message inmessage, Message outmessage) 
{
port.setTarget(null);}
 protected void connect ( Port port) 
{
}
 protected void disconnect ( Port port) 
{
}
 protected void createConnection ( String component1,  String component2) 
{
createConnection(component1, component2, null);}
 protected void createConnection ( AbstractPort component1,  String component2) 
{
if (component1==null)
Fatal("component.createConnect()... component1==null");
createConnection(component1.toString(), component2, null);}
 protected void createConnection ( String component1,  String component2,  Object information) 
{
if (component1==null)
Fatal("component.createConnect()... component1==null");
if (component2==null)
Fatal("component.createConnect()... component2==null");
 Message inmessage = new Message ();
 Message outmessage = new Message (inmessage);
{ outmessage.putField("Invoke","SetupConnection");
outmessage.putField("ComponentA",component1);
outmessage.putField("ComponentB",component2);
outmessage.putField("Information",information);
(system).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 protected Port createPort ( String name) 
{
return new Port (name, this);}
 protected MultiPort createMultiPort ( String name) 
{
return new MultiPort (name, this);}
 protected Port createPort ( String name,  Object maponto) 
{
return new Port (name, this, new InvocationMessageHandler (this, maponto));}
 protected MultiPort createMultiPort ( String name,  Object maponto) 
{
return new MultiPort (name, this, new InvocationMessageHandler (this, maponto));}
 protected MultiPort createMultiPortWithCreator ( String name,  MessageHandlerCreator mhc) 
{
return new MultiPort (name, this, mhc);}
 public Component (){system=createPort("system"); self=createPort("self"); self.setTarget(self.getId()); }public String toString () 
{
return name;}
 public void setImpl ( ComponentImpl i) 
{
impl=i;}
 public void acceptOldComponent ( Component old) 
{
}
 public State getState () 
{
return null;}
 protected SetupPort createComponent ( String blueprint,  String name) 
{
return new SetupPort (this, blueprint, name);}
 public void sendCreateComponent ( String blueprint,  String name,  Message m) 
{
 Message inmessage = new Message ();
 Message outmessage = inmessage.copy();
{ outmessage.putField("Invoke","CreateComponent");
outmessage.putField("Message",m);
outmessage.putField("BluePrint",blueprint);
outmessage.putField("Instance",name);
(system).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 public synchronized void  Freeze(Port port, Message inmessage, Message outmessage) 
{
self.unlink();
{ outmessage.putField("Invoke","FreezeOk");
(port).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 public synchronized void  Init(Port port, Message inmessage, Message outmessage) 
{
}
 public void filterSendMessage ( AbstractPort p,  Message m) 
{
impl.filterSendMessage(p, m);}
 public void filterReceiveMessage ( AbstractPort p,  Message m) 
{
impl.filterReceiveMessage(p, m);}
 public synchronized void  NoSuchMessage(Port port, Message inmessage, Message outmessage) 
{
System.out.println("Warning: "+name+" cannot handle message "+inmessage.getField("Message"));}
 public synchronized void  GetComponentName(Port port, Message inmessage, Message outmessage) 
{
{ outmessage.putField("Invoke","ComponentName");
outmessage.putField("Name",name);
(port).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 }

;