package component.system;

import java.io.Serializable;

final class Connection implements Serializable
{     
  PortAddress componentA;
  PortAddress componentB;
  PortAddress portA;
  PortAddress portB;
  Object info;
  public Connection(PortAddress A, PortAddress B, Object I)
    {
    componentA=A;
    componentB=B;
    info=I;
    portA=null;
    portB=null;
    }
  public void setPortA(PortAddress a)
    {
    portA=a;
    }
  public void setPortB(PortAddress b)
    {
    portB=b;
    }
  public PortAddress getPortA()
    {
    return portA;
    }
  public PortAddress getPortB()
    {
    return portB;
    }
  public PortAddress getComponentA()
    {
    return componentA;
    }
  public PortAddress getComponentB()
    {
    return componentB;
    }
  public Object getInformation()
    {
    return info;
    }
}     

