package component.system;

/* het dees is een abstracte interrupthandle classe, gesynchronized
 * op een aantal plaatsen om concurrentieproblemen tegen te gaan/ op te
 * vangen
 */

abstract public class InterruptHandler  
extends component.glue.Observable
{ 
  public void handleMessage(Message m) throws Exception
  {
    synchronized(this)
      {
	super.handleMessage(m);
      }
  }
  
  protected void notify(String name, Object value)
  {
    synchronized(this)
      {
	super.notify(name, value);
      }
  }
}
