package component.system;
/** 
 * Deze klasse is een voorbeeld van hoe een eventueel nieuwe 
 * scheduler geimplemnteerd kan worden door de Schedule klasse 
 * te overriden. Merk op dat deze classe concurrentieproblemen 
 * geeft daar target-componenten concurrent opgeroepen kunnen 
 * worden. 
 */

public class StupidScheduler extends StandardScheduler{    
   public StupidScheduler(int tC)	    
     {
	super(tC);
     }   
   public void run()	    
     {
	int currentout=0;	
	while(true)		
	  {
	     Message m=(Message)inQ.pop();
	     outQs[currentout++].push(m);	
	     currentout%=threadCount;
	  }
     } 
   public String toString() 
     {
	return "Stupid Scheduler [" + threadCount + "]";
     }
}
