package component.system.util;

class Entry 
{
   Object value;
   Entry next; 
}

public class UtilLinkedList 
{
   Entry first, last; 
   int size; 
   
   public UtilLinkedList () 
     {
	first = last = null; 
	size = 0; 
     }

   public int size () 
     {
	return size; 
     }
   
   public Object get (int i) 
     {
	if (i >= size || i < 0) return null;
	Entry e = first;
	for (int j = 0; j < i; j++) 
	  e = e.next;  
	return e.value; 
     }
 
   public void addLast (Object o) 
     {
	Entry e = new Entry ();
	e.value = o;
	if (size == 0) 
	  first = last = e;
	else 
	  {
	     last.next = e;
	     last = e;
	  }
	size ++; 
     }
   
   public boolean isEmpty () 
     {
	return size == 0;
     }
   
   public Object getFirst () 
     {
	Object retVal; 
	if (size == 0) 
	  retVal = null;
	else 
	  retVal = first.value;
	return retVal; 
     }
   
   public Object removeFirst () 
     {
	Object retVal; 
	if (size == 0) 
	  return retVal = null;
	retVal = first.value;
	size --; 
	if (size == 0)
	  first = last = null;
	else 
	  first = first.next;
	return retVal; 
     }
}
