package component.system;

public class MessageEntry {
	public Message message;
	public long deadline;
	public MessageEntry next;
	
	public MessageEntry(long deadline, Message message) {
		this(deadline,message,null);
	}
	
	public MessageEntry(long deadline, Message message, MessageEntry messageEntry) {
		this.deadline = deadline;
		this.message = message;
		this.next = messageEntry;
	}
}