/* Component Parser Version 1.7 -- Generated Code */
package component.examples.concurrentplayfield;
import component.system.*;
import component.concurrency.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

 class Square extends Global
 implements Comparable

{ boolean free; Color color;public Square (){color=Color.white; free=true; }public void paint ( Graphics g,  int x,  int y) 
{
g.setColor(color);
g.fillRect(x*10, y*10, 9, 9);}
 public boolean isFree () 
{
return free;}
 public void setActor ( int t) 
{
if (t==0)
{
free=true;
color=color.darker();}

else free=false;
if (t==1)
color=Color.red;
else if (t==2)
color=Color.green;
else if (t==3)
color=Color.blue;
else if (t==4)
color=Color.yellow;
else if (t==5)
color=Color.gray;
else if (t==6)
color=Color.red;
else if (t==7)
color=Color.cyan;
else if (t==8)
color=Color.magenta;}
 public int compareTo ( Object o) 
{
 int a;
 int b;
a=o.hashCode();
b=hashCode();
if (a<b)
return 1;
else if (a>b)
return -1;
else return 0;}
 }

;
 class PlayFieldShower extends Canvas

{ PlayField redirect;public PlayFieldShower ( PlayField redir){super();  Frame frame = new Frame ("PlayField"); redirect=redir; frame.add(this); frame.show(); }public void update ( Graphics g) 
{
redirect.paint(g);}
 public void paint ( Graphics g) 
{
redirect.paint(g);}
 }

;
public class PlayField implements MessageHandlerCreator

{public final static int XSIZ = 100;public final static int YSIZ = 100; public MultiPort  actors;public Square field [] []; Canvas shower;public PlayField (){actors=new MultiPort ("actors", this); }public MessageHandler getMessageHandler ( String name) 
{
return new InvocationMessageHandler (this, new PlayActor (this));}
 public synchronized void  Init(Port port, Message inmessage, Message outmessage) 
{
 int x, y;
field=new Square [XSIZ][YSIZ];
for(x=0;x<XSIZ;x++)for(y=0;y<YSIZ;y++)field[x][y]=new Square ();
for(x=0;x<XSIZ;x++){
field[x][0].setActor(1);
field[x][YSIZ-1].setActor(1);}

for(y=0;y<YSIZ;y++){
field[0][y].setActor(1);
field[XSIZ-1][y].setActor(1);}

shower=new PlayFieldShower (this);}
 public void repaint () 
{
shower.repaint();}
 public void paint ( Graphics g) 
{
 int x, y;
for(x=0;x<XSIZ;x++)for(y=0;y<YSIZ;y++)field[x][y].paint(g, x, y);}
 }

;