package component.examples.java_problems;
import java.net.*;
import java.io.*;

public class DeserialReceiver
{
   public DeserialReceiver(String args[])
     {
	try
	  {
	     ServerSocket serversocket = new ServerSocket(8081);
	     System.out.println("Listening on port 8081");
	     Socket socket = serversocket.accept();
	     System.out.println("Connection accepted");
	     InputStream is =  socket.getInputStream();
	     ObjectInputStream ois = new ObjectInputStream(is);
	     while(true)
	       {
		  Object o = ois.readObject();
		  System.out.println("Received a certain object");
	       }
	  }
	catch (Exception e)
	  {
	     System.out.println(e);
	  }
     }
   static public void main(String args[])
     {
	new DeserialReceiver(args);
     }
}
