package component.examples.java_problems;
import java.net.*;
import java.io.*;
import java.util.*;

/**
 * This class can open a connection to another listening TCP/IP socket.
 */

class TenMegChunk
  implements Serializable
{
   byte yeah[];
   public TenMegChunk()
     {
	yeah = new byte[10*1024*1024];
     }
}

public class SerialSender
{
   public SerialSender(String args[])
     {
	super();
	try
	  {
	     InetAddress address = InetAddress.getByName(args[0]);
	     System.out.println("Connecting to "+address+" port 8081");
	     Socket socket = new Socket(address,8081);
	     System.out.println("Socket opened");
	     OutputStream ou = socket.getOutputStream();
	     ObjectOutputStream dataout = new ObjectOutputStream(ou);
	     System.out.println("Allocating array of 10M");
	     System.out.println("Sending data");
	     long now = new Date().getTime();
	     int i =0;
	     while (i<20)
	       {
		  dataout.writeObject(new TenMegChunk());
		  dataout.reset();
		  System.out.println("Sent a chunk");
		  i++;
	       }
	     now = new Date().getTime()-now;
	     System.out.println("Done (time = "+now+" ms)");
	     System.out.println(" --> "+10*20*1024*1000/now+" k/s");
	     System.out.println(" --> "+10*20*1000/now+" M/s");
	  }
	catch (Exception e)
	  {
	     System.out.println(e);
	  }
     }
   static public void main(String args[])
     {
	new SerialSender(args);
     }
}
