package component.examples.java_problems;
import java.net.*;
import java.io.*;

public class SocketReceiver
{
   public SocketReceiver(String args[])
     {
	try
	  {
	     ServerSocket serversocket = new ServerSocket(8081);
	     System.out.println("Listening on port 8081");
	     Socket socket = serversocket.accept();
	     System.out.println("Connection accepted");
	     InputStream inputstream =  socket.getInputStream();
	     System.out.println("Allocating 10M ''buffer''");
	     byte yeah[] = new byte[10*1024*1024];
	     int numberread = 0;
	     while(numberread<10*1024*1024)
	       {
		  int r = inputstream.read(yeah,numberread,10*1024*1024-numberread);
		  System.out.println("Received "+r+" bytes (total = "+numberread/1024+"k)");
		  if (r<0) return;
		  numberread+=r;
	       }
	  }
	catch (Exception e)
	  {
	     System.out.println(e);
	  }
     }
   static public void main(String args[])
     {
	new SocketReceiver(args);
     }
}
