package component.parser;
public class ASTArrayDimsAndInits 
  extends SimpleNode 
{
  public ASTArrayDimsAndInits(int id) 
     {
	super(id);
     }
   public void generateSource()
     {
	if (fields==null)
	  {
	     output("[]");
	     generateChildSources();
	  }
	else
	  {
	     int i=0;
	     while(i<fields.length) 
	       {
		  output("[");
		  if (children != null && i<children.length)
		    {
		       SimpleNode n = (SimpleNode)children[i];
		       if (n != null)
			 n.generateSource();
		    }
		  output("]");
		  i++;
	       }
	  }
     }
}
