package component.parser;
import component.productions.*;

public class ASTBlockStatement extends SimpleNode {
  public ASTBlockStatement(int id) {
    super(id);
  }
  public void generateSource()
  {
    generateChildSources();
    if (children[0] instanceof ASTLocalVariableDeclaration) output(";");
  }

  public Production generateProductions()
  {
    return ((SimpleNode)children[0]).generateProductions();
  }
}
