package component.parser;
import component.productions.*;

public class ASTConditionalExpression extends SimpleNode {
  public ASTConditionalExpression(int id) {super(id);}
  public void generateSource()
  {
    ((SimpleNode)children[0]).generateSource();
    if (children.length>1)
    	{output(" ? ");
    	((SimpleNode)children[1]).generateSource();
        output(" : ");
	    ((SimpleNode)children[2]).generateSource();}
  }

  public Production generateProductions()
	{
        Production result=null;
        // generate predictate productions
        result=generateProductions(0);
        // generate eventually other productions and append them
        if (children.length==3)
	        {Production l,r;
        	Production or;
            l=((SimpleNode)children[1]).generateProductions();
            r=((SimpleNode)children[2]).generateProductions();
        	or=Production.choice(l,r);
            return Production.sequence(result,or);}
        return result;
  	}
}
