package component.parser;
import component.productions.*;

// WVB -- checken dat er geen berichten verstuurd worden in nen constructor 
// WVB -- checken dat er geen overdadige constructoren aanwezig zijn !

public class ASTConstructorDeclaration extends SimpleNode
{
   public ASTConstructorDeclaration(int id) {super(id);}
   public void generateSource()
     { 
	int i=1;
        outputFields(" ");
        output(" ");
        ((SimpleNode)children[0]).generateSource();
        if (children.length>=2 && children[1] instanceof ASTNameList)
	  {
	     output(" throws ");
	     ((SimpleNode)children[1]).generateSource();
	     i=2;
	  }
	output("{");
	while(i<children.length)
	  {
	     ((SimpleNode)children[i]).generateSource();
	     output(" ");
	     i=i+1;
	  }
        output("}");
     }
   public Production generateProductions()
     {
	/* constructors mogen normaal geen berichtenverzenden... */
	return null;
     }
}
