package component.parser;
import component.productions.*;

public class ASTDoStatement extends SimpleNode {
  public ASTDoStatement(int id) {super(id);}
  public void generateSource()
  	{
    output("do\n");
  	((SimpleNode)children[0]).generateSource();
  	output("while (");
  	((SimpleNode)children[1]).generateSource();
    output(");\n");
  	}
  public Production generateProductions()
    {
    return Production.loop(sequenceChildProductions());
  	}
}
