package component.parser;
import component.productions.*;

public class ASTFieldDeclaration extends SimpleNode 
{
   public ASTFieldDeclaration(int id) 
     {
	super(id);
     }
   public Production generateProductions()
     {
	if (getCurrentMethodName()==null) return null;
	return sequenceChildProductions();
     }
   public void generateSource()
     {
	SimpleNode a,b;
	boolean typewritten=false;
	int i=2;
	outputFields(" ");
	output(" ");
	a=(SimpleNode)children[0];
	if (a!=null)
	  {
	     b=(SimpleNode)a.children[0];
	     if (b instanceof ASTName)
	       {
		  if ("multiport".compareTo((String)b.fields[0])==0)
		    {
		       output("public MultiPort ");
		       typewritten=true;
		    }
		  else if ("port".compareTo((String)b.fields[0])==0)
		    {
		       output("public Port ");
		       typewritten=true;
		    }
	       }
	  }
	if (!typewritten) ((SimpleNode)children[0]).generateSource();
	output(" ");
	((SimpleNode)children[1]).generateSource();
	while(i<children.length)
	  {
	     output(", ");
	     ((SimpleNode)children[i]).generateSource();
	     i=i+1;
	  }
	output(";");
     }
}
