package component.parser;
import component.productions.*;

public class ASTIfStatement extends SimpleNode 
{
   public ASTIfStatement(int id) 
     {super(id);}
   public void generateSource()
     {
	SimpleNode c;
	output("if (");
	c=(SimpleNode)children[0];
	c.generateSource();
	output(")\n");
	c=(SimpleNode)children[1];
	c.generateSource();
	if (children.length==3)
	  {
	     output("\nelse ");	
	     c=(SimpleNode)children[2];
	     c.generateSource();
	  }
     }
   public Production generateProductions()
     {
	/* Predicaat wordt altjid uitgevoerd, 
	 * de andere zijn lazies die gesequenced moeten worden dacht ik
	 */
	Production p,t,f;
	p=((SimpleNode)children[0]).generateProductions();
	t=((SimpleNode)children[1]).generateProductions();
	if (children.length==3)
	  f=((SimpleNode)children[2]).generateProductions();
	else f=null;
	return Production.sequence(p,Production.choice(t,f));
     }
}
