package component.parser;
import component.productions.*;

public class ASTMethodDeclarator
  extends SimpleNode
{
   public ASTMethodDeclarator(int id)
     {
	super(id);
     }
   public void generateSource()
     {
	int i=1;
	output(fields[0]);
	output(" ");
	generateChildSources();
	while(i<fields.length)
	  output(fields[i++]);
     }
   
   public Production generateProductions()
     {
	Term r;
	setCurrentMethodName(fields[0]);
	r=new Term(getCurrentClassName(),getCurrentMethodName());
	r.addField("Return","*");
	return r;
     }
}
