package component.productions;

public class Term extends Production
{
   private String target;
   private String invoke;
   private String[] fields;
   private String[] values;
   public Term(String T, String I)
     {
	super();
	target=T;
        invoke=I;
        fields=new String[0];
        values=new String[0];
     }
   public Production deepCopy()
     {
        Term t=new Term(target,invoke);
    	t.fields=fields;
        t.values=values;
        return t;
     }
   public Production createTry()
     {
	return deepCopy();
     }
   public void addField(String var, String val)
     {
	int i,s = values.length;
	// zoek hem op, zit hem der in, verander value
	for(i=0;i<s;i++)
	  {
	     if (fields[i].compareTo(var)==0) 
	       {
		  values[i]=val;
		  return;
	       }
	  }
	// breid uit anders
	String[] nvars=new String[s+1]; 
	String[] nvals=new String[s+1];
	for(i=0;i<s;i++)
	  {
	     nvars[i]=fields[i];
	     nvals[i]=values[i];
	  }
	nvars[s]=var;
	nvals[s]=val;
	fields=nvars;
	values=nvals;
     }
   public String toString() 
     {
	int i;
	String result=target+"."+invoke+"(";
	for(i=0;i<fields.length;i++)
	  {
	     if (fields[i]!=null) result+=fields[i]+":";
	     if (values[i]==null) result+="*";
	     else result+=values[i];
	     if (i<fields.length-1) result+=",";
	  }
	return result+")";
     }
   protected Production remangleGetFields()
     {
	// WVB -- warning deze getfields worden geignored omdat er toch nooit
	// iets deftig instaat (dunkt me)
	return this;
     }
}
