package component.system;
import java.lang.reflect.*;
import java.util.*;

public class ComponentImpl
  extends Global
{
   Component component;
   public ComponentImpl(Component wrapper)
     {
	component=wrapper;
     }

   public void filterSendMessage(AbstractPort p, Message m)
     {
	synchronized(component)
	  {
	     p.doSendMessage(m);
	  }
     }
   public void filterReceiveMessage(AbstractPort p, Message m)
     {
	synchronized(component)
	  {
	     p.doReceiveMessage(m);
	  }
     }
}
