package component.system;

/**
 * This class is a simple loop which takes a message of a queue and
 * sends it to the right component by calling handleMessage upon that
 * component.
 */ 
class ExecutionLoop extends Thread
{
   private MessageQueue mqueue;
   
   public ExecutionLoop(MessageQueue q)
     {
	mqueue=q;
	start();
     }
   public void run()
     {
	while(true)
	  {
	     // vroeger stond hier onmiddelijk een pop
	     // dit was helaas niet juist, het was mogelijk
	     // dat de laatste message (voor component A) van de queue gehaald werd
	     // waardoor de volgende message direct op dezelfde queue geduwd werd.
	     // Daarom doen we nu eerst een top. En nadien direct een pop
	     Message m=(Message)mqueue.top();
	     ComponentSystem.doReceiveMessage(m);
	     mqueue.pop();
	  }
     }
}
