package component.system;

abstract public class Global
{
   /**
    * This method can be called by anybody wanting to 
    * terminate the application
    * If an exception is given a stack trace is printed.
    */
   public static void Fatal(String str, Throwable e)
     {
	if (e!=null)
	  {
	     System.out.println(e);
	     e.printStackTrace();
	  }
	System.out.println("\nFatal: "+str+"\n");
	System.exit(56);
     }
   
   public static void Fatal(String str)
     {
	Fatal(str,new Exception());
     }
   
   public static void Warning(String str)
     {
	System.out.println("Warning: "+str);
     }
}
