package component.system;

class MessageDispatcher 
  extends Global
  implements MessageHandler
{
   static public void forwardMessage(Port p, Message m, Port to)
     {
	 //	System.out.println("Suddenly forwarding a message coming over "+p);
	m=m.copy();
	if (p!=null)
	  {
	     m.putHiddenField("Requester",p.getId());
//	     System.out.println("Setting requester to "+p.getId());
//	     m.dump();
	  }
	else
	  {
//	     System.out.println("Port seems to be zip");
	  }
	to.sendMessage(m);
     }
   public void handleMessage(Port p, Message msg)
    {
	//	System.out.println("Suddenly handling a message coming over "+p);
	PortAddress requestCameFrom=(PortAddress)msg.getHiddenField("Requester");
	if (requestCameFrom==null)
	  {
//	     msg.dump();
//	     Fatal("componentsystem: returning a message over a hook which is not connected (ReceiveMessage ??)");
	  }
	else
	    {
		Port target=ComponentSystem.lookupDirectPort(requestCameFrom);
		target.sendMessage(msg);
	    }
     }
}
