package component.system;

public class SameHandlerCreator
  implements MessageHandlerCreator
{
   private MessageHandler handleby;
   public SameHandlerCreator(Component owner, Object o)
     {
	handleby=new InvocationMessageHandler(owner,o);
     }
   public SameHandlerCreator(Component owner)
     {
	handleby=new InvocationMessageHandler(owner,owner);
     }
   public SameHandlerCreator(MessageHandler mh)
     {
	handleby=mh;
     }
   public MessageHandler getMessageHandler(String name)
     {
	return handleby;
     }
}
